Show / Hide Table of Contents

# Class GameVersion

A GameVersion object contains give hierarchical numeric components: year, month, day, major and minor. All components may be unspecified, which is represented internally as a -1. By definition, an unspecified component matches anything (both unspecified and specified), and an unspecified component is "less than" any specified component. It will also equal the string "any" if all components are unspecified. The value can be retrieved from the ffxivgame.ver file in your game installation directory.

##### Inheritance

System.Object
GameVersion

##### Implements

System.ICloneable
System.IComparable
System.IComparable<GameVersion>
System.IEquatable<GameVersion>

##### Inherited Members

System.Object.Equals(System.Object, System.Object)
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: Dalamud.Game

###### Assembly: Dalamud.dll

##### Syntax

    [Serializable]
    public sealed class GameVersion : ICloneable, IComparable, IComparable<GameVersion>, IEquatable<GameVersion>

### Constructors

| Improve this Doc View Source

#### GameVersion()

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion()

| Improve this Doc View Source

#### GameVersion(Int32)

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion(int year)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | year | The year.

| Improve this Doc View Source

#### GameVersion(Int32, Int32)

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion(int year, int month)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | year | The year.
System.Int32 | month | The month.

| Improve this Doc View Source

#### GameVersion(Int32, Int32, Int32)

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion(int year, int month, int day)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | year | The year.
System.Int32 | month | The month.
System.Int32 | day | The day.

| Improve this Doc View Source

#### GameVersion(Int32, Int32, Int32, Int32)

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion(int year, int month, int day, int major)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | year | The year.
System.Int32 | month | The month.
System.Int32 | day | The day.
System.Int32 | major | The major version.

| Improve this Doc View Source

#### GameVersion(Int32, Int32, Int32, Int32, Int32)

Initializes a new instance of the GameVersion class.

##### Declaration

    public GameVersion(int year, int month, int day, int major, int minor)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | year | The year.
System.Int32 | month | The month.
System.Int32 | day | The day.
System.Int32 | major | The major version.
System.Int32 | minor | The minor version.

| Improve this Doc View Source

#### GameVersion(String)

Initializes a new instance of the GameVersion class.

##### Declaration

    [JsonConstructor]
    public GameVersion(string version)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | version | Version string to parse.

### Properties

| Improve this Doc View Source

#### Any

Gets the default "any" game version.

##### Declaration

    public static GameVersion Any { get; }

##### Property Value

Type | Description
--- | ---
GameVersion |

| Improve this Doc View Source

#### Day

Gets the day component.

##### Declaration

    public int Day { get; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### Major

Gets the major version component.

##### Declaration

    public int Major { get; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### Minor

Gets the minor version component.

##### Declaration

    public int Minor { get; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### Month

Gets the month component.

##### Declaration

    public int Month { get; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### Year

Gets the year component.

##### Declaration

    public int Year { get; }

##### Property Value

Type | Description
--- | ---
System.Int32 |

### Methods

| Improve this Doc View Source

#### Clone()

##### Declaration

    public object Clone()

##### Returns

Type | Description
--- | ---
System.Object |

| Improve this Doc View Source

#### CompareTo(GameVersion)

##### Declaration

    public int CompareTo(GameVersion value)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | value |

##### Returns

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### CompareTo(Object)

##### Declaration

    public int CompareTo(object obj)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Object | obj |

##### Returns

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### Equals(GameVersion)

##### Declaration

    public bool Equals(GameVersion value)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | value |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Equals(Object)

##### Declaration

    public override bool Equals(object obj)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Object | obj |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

System.Object.Equals(System.Object)
| Improve this Doc View Source

#### GetHashCode()

##### Declaration

    public override int GetHashCode()

##### Returns

Type | Description
--- | ---
System.Int32 |

##### Overrides

System.Object.GetHashCode()
| Improve this Doc View Source

#### Parse(String)

Parse a version string. YYYY.MM.DD.majr.minr or "any".

##### Declaration

    public static GameVersion Parse(string input)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | input | Input to parse.

##### Returns

Type | Description
--- | ---
GameVersion | GameVersion object.

| Improve this Doc View Source

#### ToString()

##### Declaration

    public override string ToString()

##### Returns

Type | Description
--- | ---
System.String |

##### Overrides

System.Object.ToString()
| Improve this Doc View Source

#### TryParse(String, out GameVersion)

Try to parse a version string. YYYY.MM.DD.majr.minr or "any".

##### Declaration

    public static bool TryParse(string input, out GameVersion result)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | input | Input to parse.
GameVersion | result | GameVersion object.

##### Returns

Type | Description
--- | ---
System.Boolean | Success or failure.

### Operators

| Improve this Doc View Source

#### Addition(GameVersion, TimeSpan)

##### Declaration

    public static GameVersion operator +(GameVersion v1, TimeSpan v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
System.TimeSpan | v2 |

##### Returns

Type | Description
--- | ---
GameVersion |

| Improve this Doc View Source

#### Equality(GameVersion, GameVersion)

##### Declaration

    public static bool operator ==(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### GreaterThan(GameVersion, GameVersion)

##### Declaration

    public static bool operator>(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### GreaterThanOrEqual(GameVersion, GameVersion)

##### Declaration

    public static bool operator >=(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Implicit(String to GameVersion)

##### Declaration

    public static implicit operator GameVersion(string ver)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | ver |

##### Returns

Type | Description
--- | ---
GameVersion |

| Improve this Doc View Source

#### Inequality(GameVersion, GameVersion)

##### Declaration

    public static bool operator !=(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### LessThan(GameVersion, GameVersion)

##### Declaration

    public static bool operator <(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### LessThanOrEqual(GameVersion, GameVersion)

##### Declaration

    public static bool operator <=(GameVersion v1, GameVersion v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
GameVersion | v2 |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Subtraction(GameVersion, TimeSpan)

##### Declaration

    public static GameVersion operator -(GameVersion v1, TimeSpan v2)

##### Parameters

Type | Name | Description
--- | --- | ---
GameVersion | v1 |
System.TimeSpan | v2 |

##### Returns

Type | Description
--- | ---
GameVersion |

### Implements

System.ICloneable
System.IComparable
System.IComparable<T>
System.IEquatable<T>